from turtle import *
from math import sqrt

def triangle_drawing_1(x, y, size):
    # Base Case
    if size < 10:
        return 0

    # Recursive Case
    draw_triangle(x, y, size, colorstring(size))
    num_recursive_triangles = triangle_drawing_1(x, y, size/2)
    return num_recursive_triangles + 1


def triangle_drawing_2(x,y,size):
    # Base Case
    if size < 20:
        draw_triangle(x, y, size, "blue")
        return 1

    # Recursive Case
    n1 = triangle_drawing_2(x,y, size/2)
    n2 = triangle_drawing_2(x + size/2, y, size/2)
    n3 = triangle_drawing_2(x + size/4, y + triangle_height(size)/2, size/2)
    return n1 + n2 + n3

def triangle_drawing_3(n,x,y,size):
    # Base Case
    if n <= 0:
        return 0

    # Recursive Case

    # draw a line of triangles
    for i in range(n):
        draw_triangle(x + i*size,y,size,"blue")
    return n + triangle_drawing_3(n-1, x+size/2, y + triangle_height(size), size)


def main():
    speed(0)

    #forward(300)
    #left(90)
    #forward(300)
    #draw_triangle(-100,200,150)

    #n = triangle_drawing_1(0,0,400)
    #print(n)
    #print(triangle_drawing_2(-80,-80,400))
    triangle_drawing_3(6,-180,-100,60)
    hideturtle()
    done()




def draw_triangle(x, y, size, color=None):
    """
    draws a equilateral triangle with edges of length size
    starting at position (x,y)
    :param x: (int or float) initial x-coordinate
    :param y: (int or float) initial y-coordinate
    :param size: (int or float) length of each edge
    :param color: (string, optional): fill color of the triangle
    :return: None
    """
    penup()
    setposition(x, y)
    setheading(0)
    pendown()

    if color != None:
        fillcolor(color)
        begin_fill()

    for i in range(3):
        forward(size)
        left(120)

    if color != None:
        end_fill()


def triangle_height(side):
    """
    Computes the height of an equilateral triangle with sides of length <size>
    :param side: (int or float) length of each side
    :return: (int or float) the height of the equilateral triangle
    """
    return sqrt(side ** 2 - (side / 2) ** 2)  # use Pythagorean thm


def decimal_to_hex(digit):
    assert digit >= 0 and digit <= 16
    if digit < 10:
        return str(digit)
    elif digit == 10:
        return "a"
    elif digit == 11:
        return "b"
    elif digit == 12:
        return "c"
    elif digit == 13:
        return "d"
    elif digit == 14:
        return "e"
    else:
        return "f"


def colorstring(num):
    if num > 256:
        num = 256
    elif num < 0:
        num = 0

    digit1 = int(num) // 16
    digit2 = int(num) % 16

    char1 = decimal_to_hex(digit1)
    char2 = decimal_to_hex(digit2)

    color_str = "#"
    for color in ["red","green","blue"]:
        color_str += char1 + char2
    print(num,digit1, digit2, color_str)
    return color_str

if __name__ == "__main__":
    main()